//
//      MainWindow.cpp
//
#include "simplemailer.hpp"
#include "MainWindow.hpp"
#include "SendingWindow.hpp"
#include "ReceivedWindow.hpp"
#include "OptionWindow.hpp"
#define MARGIN 16

// RXgN^
MainWindow::MainWindow(Void) : SFRTitleWindow(SFRApplication::GetInstance(),
SFXGraphics::GetDeviceRectangle(), "Simple Mailer") static_throws
{
    // L[ nho^
    if (static_try()) {
        static_throw(
        RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    // tHg̍擾
    SInt16 fontHeight = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
    // {^̕vZ
    SInt16 width = SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, "[M");
    // [̃XN[̕ƍ擾
    SFXDevice device;
    UInt16 ScreenWidth = device.GetScreenWidth();
    SInt16 ScreenHeight = device.GetScreenHeight();
    // [̃XN[̐^Ń{^ʒuvZ
    SInt16 position_X = ( ScreenWidth- (width + 2 * MARGIN))/2;
    SInt16 position_Y = ( ScreenHeight- ( 4 * fontHeight + 3 * MARGIN )- fontHeight )/2;
    SFXRectangle rectangle(position_X, position_Y, width + 2 * MARGIN, fontHeight + 2);
    // {^̍쐬
    SFRButtonControlPtr button1 = ::new SFRButtonControl(this,
    rectangle, "[M");
    rectangle.AddY(fontHeight + MARGIN);
    SFRButtonControlPtr button2 = ::new SFRButtonControl(this,
    rectangle, "[M");
    rectangle.AddY(fontHeight + MARGIN);
    SFRButtonControlPtr button3 = ::new SFRButtonControl(this,
    rectangle, "ݒ");
    rectangle.AddY(fontHeight + MARGIN);
    SFRButtonControlPtr button4 = ::new SFRButtonControl(this,
    rectangle, "I");
    // {^nh̓o^
    if (static_try() && button1 != null) {
        static_throw(
        button1->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControl1)));
        if (static_try()) {
            // tH[JX𓖂Ă
            button1->SetStatusFocus(true);
        }
    }
    if (static_try() && button2 != null) {
        static_throw(
        button2->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControl2)));
    }
    if (static_try() && button3 != null) {
        static_throw(
        button3->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControl3)));
    }
    if (static_try() && button4 != null) {
        static_throw(
        button4->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControl4)));
    }
    return;
}


// fXgN^
MainWindow::~MainWindow(Void)
{
    return;
}


// L[ nhiEBhEOʂɂƂɃL[Ǝsj
HANDLER_IMPLEMENT_BOOLEVENT(MainWindow, OnKey, event)
{
    UInt16 key = event.GetP16();
    switch (key)
    {
    case AVK_UP:
        // tH[JXɈړ
        FocusUp();
        return true;
    case AVK_DOWN:
        // tH[JXɈړ
        FocusDown();
        return true;
    case AVK_CLR:
        // Av[P[VI
        SFRApplication::Terminate();
        return true;
    }
    return false;
}


HANDLER_IMPLEMENT_VOIDCONTROL(MainWindow, OnButtonControl1, result, control)
{
    unused(result);
    unused(control);

    // MEChEJ
    ::new SendingWindow();
}


HANDLER_IMPLEMENT_VOIDCONTROL(MainWindow, OnButtonControl2, result, control)
{
    unused(result);
    unused(control);

    // [̎MƎMJn
    SFCError error;
    SFXConfigPtr option = simplemailer::GetOption();
    // AJEg ([UƃpX[h) ݒ
    _receiver.SetAccount(option->ReadSFXAnsiString(OPTION_USER, ""),
    option->ReadSFXAnsiString(OPTION_PASSWORD, ""),
    SFXPOP3Receiver::AUTH_ONLY_USERPASS);
    //SFXPOP3Receiver::AUTH_ONLY_USERPASS ̓pX[hFؕ@AT[oɂĈႢ܂B
    //̗ yahoo.co.jp ̃[T[oł
    // Mp[T[oƃ|[gԍw (hC͎)
    _receiver.SetServer(SFXSocketAddress(
    option->ReadSFXAnsiString(OPTION_POP3SERVER, ""),
    option->ReadUInt16(OPTION_POP3PORT, 110)));
    // [M (R[obNo^)
    // M[폜邩ǂ
    Bool UseSSL=option->ReadBool(OPTION_USESSL, false);
    _receiver.SetSSLMode(UseSSL);
    if (UseSSL)
    {
        SInt16 trustmode=option->ReadSInt16(OPTION_SSLTRUSTMODE,0);
        switch (trustmode)
        {
        case 0:
        default:
            _receiver.SetTrustMode(SSL_TRUST_MODE_FAIL);
            break;
        case 1:
            _receiver.SetTrustMode(SSL_TRUST_MODE_CHECK);
            break;
        case 2:
            _receiver.SetTrustMode(SSL_TRUST_MODE_IGNORE);
            break;
        case 3:
            _receiver.SetTrustMode(SSL_TRUST_MODE_ALWAYS);
            break;
        }
    }
    if (option->ReadBool(OPTION_ERASEMAIL, false)) {
        // Mƍ폜
        error = _receiver.ReceiveAndDelete(XALLBACK_INTERNAL(POP3Callback));
    }
    else {
        // M
        error = _receiver.Receive(XALLBACK_INTERNAL(POP3Callback));
    }
    if (error == SFERR_NO_ERROR) {
        // G[NȂ
        // _CAO̍쐬
        _dialog = ::new SFRMessageDialog(SFXGraphics::GetDeviceRectangle().Deflate(20, 80), "Mc", "LZ");
        if (_dialog != null) {
            // _CAOnh̓o^
            _dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE,
            HANDLER_FUNCTION(OnReceiving));
        }
    }
    else {
        // _CAO̍쐬
        _dialog = ::new SFRMessageDialog(SFXGraphics::GetDeviceRectangle().Deflate(20, 80), "Ms܂B", "OK");
    }
}


HANDLER_IMPLEMENT_VOIDCONTROL(MainWindow, OnButtonControl3, result, control)
{
    unused(result);
    unused(control);

    // ݒEBhEJ
    ::new OptionWindow();
}


HANDLER_IMPLEMENT_VOIDCONTROL(MainWindow, OnButtonControl4, result, control)
{
    unused(result);
    unused(control);

    // Av[P[VI
    SFRApplication::Terminate();
}


// M or sĂяoR[obN
XALLBACK_IMPLEMENT_SFXPOP3RECEIVER(MainWindow, POP3Callback, error)
{
    SFXWideString message;
    SFXPropertyPtr mail;
    SInt32 i;
    if (_dialog != null) {
        // uMcv_CAO
        _dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
        SRP16_TERMINATE_INVOKE, true));
    }
    if (error == SFERR_NO_ERROR) {
        message.Set("Mɐ܂B");
    }
    else {
        message.Set("MɎs܂B");
    }
    // _CAO̍쐬
    _dialog = ::new SFRMessageDialog(SFXGraphics::GetDeviceRectangle()
    .Deflate(20, 80), message, "OK");
    if (error == SFERR_NO_ERROR) {
        // ꍇ̓nho^
        if (_dialog != null) {
            // _CAOnh̓o^
            _dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE,
            HANDLER_FUNCTION(OnDialog));
        }
        mail = simplemailer::GetMail();
        // M[Rs[
        const SFXArray<SFXPOP3Receiver::MailInfoPtr>& mailArray =
        _receiver.GetReceivedMailArray();
        for (i = 0; i < mailArray.GetSize(); ++i) {
            SFXPOP3Receiver::MailInfoPtr minfo = mailArray[i];
            mail->Set(minfo->uidl, minfo->mail);
        }
    }
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
    SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
}


// _CAO nh̒`
HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, OnDialog, result, dialog)
{
    unused(result);

    // _CAO
    dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
    SRP16_TERMINATE_INVOKE, true));
    // EBhE̐
    ::new ReceivedWindow();
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
    SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, OnReceiving, result, dialog)
{
    unused(result);

    // _CAO
    dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
    SRP16_TERMINATE_INVOKE, true));
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
    SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
    _receiver.Cancel();
}

