#include "OptionWindow.hpp"
#include "simplemailer.hpp"
#define MARGIN 4
#define BUTTON_LABEL_OK     "ݒ"
#define BUTTON_LABEL_CANCEL "LZ"
#define PAN1_NAME           "T[oݒ"
#define PAN2_NAME           "ZLeB"

OptionWindow::OptionWindow(Void) : SFRTitleWindow(
SFRApplication::GetInstance(), SFXGraphics::GetDeviceRectangle(), "ݒ")
{
    // AvNXݒf[^擾
    SFXConfigPtr option = simplemailer::GetOption();
    // L[ nho^
    if (static_try()) {
        static_throw(RegisterHandler(SFEVT_KEY,
        HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    // tHg̍擾
    SFRTabControlPtr tab;
    SFRTabPanePtr pan1;
    SFXRectangle      rect = GetContentWorld();

    tab = ::new SFRTabControl(this, rect);
    pan1 = ::new SFRTabPane(tab, PAN1_NAME);
    SInt16 fontHeight = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
    SFXRectangle rectLeft(MARGIN, MARGIN, 100, fontHeight + 2);
    SFXRectangle rectRight(GetContentWorld());
    rectRight.Deflate(MARGIN, MARGIN);
    rectRight.AddLeft(rectRight.GetWidth() - 70);
    rectRight.SetHeight(fontHeight + 2);
    rectLeft.SetRight(rectRight.GetLeft() - MARGIN);
    // x쐬
    ::new SFRLabelControl(pan1, rectLeft, "SMTPT[o");
    ::new SFRLabelControl(pan1, rectRight, "|[g");

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    // eLXgRg[쐬
    _textControlSMTPServer = ::new SFREditboxControl(pan1,
    rectLeft, option->ReadSFXAnsiString(OPTION_SMTPSERVER, ""));
    _textControlSMTPServer->SetInputMode(AEE_TM_LETTERS);       //̓[hݒFAt@xbg
    _textControlSMTPServer->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));
    _textControlSMTPPort = ::new SFREditboxControl(pan1,
    rectRight, SFXWideString::Format("%d",
    option->ReadUInt16(OPTION_SMTPPOPT, 25)));
    _textControlSMTPPort->SetInputMode(AEE_TM_NUMBERS);         //̓[hݒF
    _textControlSMTPPort->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

    rectLeft.AddY(MARGIN + fontHeight+8);
    rectRight.AddY(MARGIN + fontHeight+8);
    ::new SFRLabelControl(pan1, rectLeft, "POP3T[o");
    ::new SFRLabelControl(pan1, rectRight, "|[g");
    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    _textControlPOP3Server = ::new SFREditboxControl(pan1, rectLeft,
    option->ReadSFXAnsiString(OPTION_POP3SERVER, ""));
    _textControlPOP3Server->SetInputMode(AEE_TM_LETTERS);       //̓[hݒFAt@xbg
    _textControlPOP3Server->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));
    _textControlPOP3Port = ::new SFREditboxControl(pan1, rectRight,
    SFXWideString::Format("%d", option->ReadUInt16(OPTION_POP3PORT, 110)));
    _textControlPOP3Port->SetInputMode(AEE_TM_NUMBERS);         //̓[hݒF
    _textControlPOP3Port->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

    rectLeft.AddY(MARGIN + fontHeight+8);
    rectRight.AddY(MARGIN + fontHeight+8);
    rectRight.SetLeft(GetContentWorld().GetWidth() / 2);
    rectLeft.SetRight(rectRight.GetLeft() - MARGIN);
    ::new SFRLabelControl(pan1, rectLeft, "[U");
    ::new SFRLabelControl(pan1, rectRight, "pX[h");

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    _textControlUser = ::new SFREditboxControl(pan1, rectLeft,
    option->ReadSFXAnsiString(OPTION_USER, ""));
    _textControlUser->SetInputMode(AEE_TM_LETTERS);     //̓[hݒFAt@xbg
    _textControlUser->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));
    _textControlPassword = ::new SFREditboxControl(pan1, rectRight,
    option->ReadSFXAnsiString(OPTION_PASSWORD,"") );
    _textControlPassword->SetProperties(TP_PASSWORD);       //pX[h񖾕\
    _textControlPassword->SetInputMode(AEE_TM_LETTERS);     //̓[hݒFAt@xbg
    _textControlPassword->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

    rectLeft.AddY(MARGIN + fontHeight +8);
    rectLeft.SetWidth(GetContentWorld().GetWidth() - 2 * MARGIN);
    // `FbN{bNX쐬
    _checkboxEraseMail = ::new SFRCheckboxControl(pan1, rectLeft,
    "[");
    if (_checkboxEraseMail != null)
    {
        // f[^ǂݍŁA`FbN{bNXɃ`FbN (͂)
        _checkboxEraseMail->SetStatusCheck(
        option->ReadBool(OPTION_ERASEMAIL, false));
    }
    rectLeft.AddY(MARGIN + fontHeight+4);
    rectLeft.SetWidth(SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, BUTTON_LABEL_OK)
    + 2 * MARGIN +30);
    // {^쐬
    SFRButtonControlPtr buttonOk = ::new SFRButtonControl(pan1,
    rectLeft, BUTTON_LABEL_OK);
    rectLeft.AddX(rectLeft.GetWidth() + MARGIN);
    rectLeft.SetRight(GetContentWorld().GetRight() - MARGIN);
    SFRButtonControlPtr buttonCancel = ::new SFRButtonControl(pan1,
    rectLeft, BUTTON_LABEL_CANCEL);
    // {^nh̓o^
    if (static_try()) {
        static_throw(
        buttonOk->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlOk)));
    }
    if (static_try()) {
        static_throw(
        buttonCancel->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlCancel)));
    }
    if (_textControlSMTPServer != null) {
        // eLXgRg[̍őTCYݒ
        _textControlSMTPServer->SetMaxSize(64);
        // tH[JX𓖂Ă
        _textControlSMTPServer->SetStatusFocus(true);
    }
    if (_textControlSMTPPort != null) {
        _textControlSMTPPort->SetMaxSize(5);
    }
    if (_textControlPOP3Server != null) {
        _textControlPOP3Server->SetMaxSize(64);
    }
    if (_textControlPOP3Port != null) {
        _textControlPOP3Port->SetMaxSize(5);
    }
    if (_textControlUser != null) {
        _textControlUser->SetMaxSize(64);
    }
    if (_textControlPassword != null) {
        _textControlPassword->SetMaxSize(64);
    }


    SFRTabPanePtr pan2;
    pan2 = ::new SFRTabPane(tab, PAN2_NAME);
    rectLeft.SetX(MARGIN  );
    rectLeft.SetY(MARGIN );
    rectRight.SetX(MARGIN );
    rectRight.SetY(MARGIN );
    rectRight.AddLeft((GetContentWorld().GetWidth() - 2 * MARGIN)/2);

    // x쐬
    rectLeft.SetWidth(GetContentWorld().GetWidth() - 2 * MARGIN);
    _checkboxUseSSL = ::new SFRCheckboxControl(pan2, rectLeft,"SSLڑgp");
    if ( _checkboxUseSSL != null)
    {
        // f[^ǂݍŁA`FbN{bNXɃ`FbN (͂)
        _checkboxUseSSL->SetStatusCheck(option->ReadBool(OPTION_USESSL, false));
    }
    _checkboxUseSSL->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnCheckboxSSL));

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    rectLeft.SetWidth(GetContentWorld().GetWidth() - 2 * MARGIN);
    _ssltext = new SFRLabelControl(pan2, rectLeft, "SSLF؃[h:");
    if (option->ReadBool(OPTION_USESSL, false)) {
        _ssltext->SetColor(SFRLabelControl::COLOR_TITLE,SFXRGBColor(0, 0, 0, 0));
    }
    else {
        _ssltext->SetColor(SFRLabelControl::COLOR_TITLE,SFXRGBColor(150, 150, 150,0));
    }

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    rectLeft.SetWidth((GetContentWorld().GetWidth() - 2 * MARGIN)/2);
    rectRight.SetWidth((GetContentWorld().GetWidth() - 2 * MARGIN)/2);
    _radioSSLTrustmode[0] = new SFRRadiobuttonControl(pan2,rectLeft, "Fail");
    _radioSSLTrustmode[1] = new SFRRadiobuttonControl(pan2,rectRight, "Check");

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    _radioSSLTrustmode[2] = new SFRRadiobuttonControl(pan2,rectLeft, "Ingore");
    _radioSSLTrustmode[3]= new SFRRadiobuttonControl(pan2,rectRight, "Always");
    _radioSSLTrustmode[1]->Group(_radioSSLTrustmode[0]);
    _radioSSLTrustmode[2]->Group(_radioSSLTrustmode[0]);
    _radioSSLTrustmode[3]->Group(_radioSSLTrustmode[0]);

    // f[^ǂݍŁA`FbN{bNXɃ`FbN (͂)
    _radioSSLTrustmode[option->ReadSInt16(OPTION_SSLTRUSTMODE , 0)]->SetStatusCheck(true);
    if (!option->ReadBool(OPTION_USESSL, false)) {
        _radioSSLTrustmode[0]->SetStatusEnable(false);
        _radioSSLTrustmode[1]->SetStatusEnable(false);
        _radioSSLTrustmode[2]->SetStatusEnable(false);
        _radioSSLTrustmode[3]->SetStatusEnable(false);
    }

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    rectLeft.SetWidth(GetContentWorld().GetWidth() - 2 * MARGIN);
    ::new SFRLabelControl(pan2, rectLeft, "SMTPF؃[h:");

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    rectLeft.SetWidth((GetContentWorld().GetWidth() - 2 * MARGIN)/2);
    rectRight.SetWidth((GetContentWorld().GetWidth() - 2 * MARGIN)/2);
    _radioSMTPAuth[0] = new SFRRadiobuttonControl(pan2,rectLeft, "None");
    _radioSMTPAuth[1] = new SFRRadiobuttonControl(pan2,rectRight, "Plain");
    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    _radioSMTPAuth[2] = new SFRRadiobuttonControl(pan2,rectLeft, "Login");
    _radioSMTPAuth[3] = new SFRRadiobuttonControl(pan2,rectRight, "Cram MD5");

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    rectLeft.SetWidth(GetContentWorld().GetWidth() - 2 * MARGIN);
    _radioSMTPAuth[4] = new SFRRadiobuttonControl(pan2,rectLeft, "Digest MD5");
    _radioSMTPAuth[1]->Group(_radioSMTPAuth[0]);
    _radioSMTPAuth[2]->Group(_radioSMTPAuth[0]);
    _radioSMTPAuth[3]->Group(_radioSMTPAuth[0]);
    _radioSMTPAuth[4]->Group(_radioSMTPAuth[0]);
    // Digest MD5 not supported yet
    _radioSMTPAuth[4]->SetStatusEnable(false);
    // f[^ǂݍŁA`FbN{bNXɃ`FbN (͂)
    _radioSMTPAuth[option->ReadSInt16(OPTION_SMTPAUTHMODE , 0)]->SetStatusCheck(true);

    rectLeft.AddY(MARGIN + fontHeight+4);
    rectLeft.SetWidth(SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, BUTTON_LABEL_OK)
    + 2 * MARGIN +30);
    // {^쐬
    buttonOk = ::new SFRButtonControl(pan2,
    rectLeft, BUTTON_LABEL_OK);
    rectLeft.AddX(rectLeft.GetWidth() + MARGIN);
    rectLeft.SetRight(GetContentWorld().GetRight() - MARGIN);
    buttonCancel = ::new SFRButtonControl(pan2,
    rectLeft, BUTTON_LABEL_CANCEL);
    // {^nh̓o^
    if (static_try()) {
        static_throw(
        buttonOk->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlOk)));
    }
    if (static_try()) {
        static_throw(
        buttonCancel->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlCancel)));
    }
    // ZNgL[Ƃ̃nho^ (eLXgRg[p)
    if (static_try()) {
        static_throw(
        RegisterHandler(
        SFEVT_KEY, AVK_SELECT, HANDLER_AFTER,
        HANDLER_FUNCTION(SelectHandler)));
    }
    return;
}


OptionWindow::~OptionWindow(Void)
{
    return;
}


// L[ nh
HANDLER_IMPLEMENT_BOOLEVENT(OptionWindow, OnKey, event)
{
    switch (event.GetP16())
    {
    case AVK_CLR:
        // NA[ L[ꂽA
        if (_textControlSMTPServer->GetStatusTarget() || _textControlSMTPPort->GetStatusTarget() ||
        _textControlPOP3Server->GetStatusTarget() || _textControlPOP3Port->GetStatusTarget() ||
        _textControlUser->GetStatusTarget()       || _textControlPassword->GetStatusTarget()) {
            _textControlSMTPServer->SetStatusTarget(false);
            _textControlSMTPPort->SetStatusTarget(false);
            _textControlPOP3Server->SetStatusTarget(false);
            _textControlPOP3Port->SetStatusTarget(false);
            _textControlUser->SetStatusTarget(false);
            _textControlPassword->SetStatusTarget(false);
            FocusNext();
        }
        else {
            // EBhE̔j
            return Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
        }
    case AVK_UP:
        FocusPrevious(); // tH[JXֈړ
        return true;
    case AVK_DOWN:
        FocusNext(); // tH[JXֈړ
        return true;
    }
    return false;
}


HANDLER_IMPLEMENT_VOIDCONTROL(OptionWindow, OnButtonControlOk, result, control)
{
    unused(result);
    unused(control);

    // ef[^ۑ
    SFXConfigPtr option = simplemailer::GetOption();
    option->WriteSFXAnsiString(OPTION_SMTPSERVER,
    _textControlSMTPServer->GetText());
    option->WriteUInt16(OPTION_SMTPPOPT,
    static_cast<UInt16>(_textControlSMTPPort->GetText().AsUInt32()));
    option->WriteSFXAnsiString(OPTION_POP3SERVER,
    _textControlPOP3Server->GetText());
    option->WriteUInt16(OPTION_POP3PORT,
    static_cast<UInt16>(_textControlPOP3Port->GetText().AsUInt32()));
    option->WriteSFXAnsiString(OPTION_USER,
    _textControlUser->GetText());
    option->WriteSFXAnsiString(OPTION_PASSWORD,
    _textControlPassword->GetText());
    option->WriteBool(OPTION_ERASEMAIL,
    _checkboxEraseMail->GetStatusCheck());
    option->WriteBool(OPTION_USESSL,
    _checkboxUseSSL->GetStatusCheck());
    for (SInt16 t=0; t<=3;t++) {
        if (_radioSSLTrustmode[t]->GetStatusCheck()) {
            option->WriteSInt16(OPTION_SSLTRUSTMODE,t);
        }
    }
    for (SInt16 s=0; s<=4;s++) {
        if (_radioSMTPAuth[s]->GetStatusCheck()) {
            option->WriteSInt16(OPTION_SMTPAUTHMODE,s);
        }
    }
    option->Save();
    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}


HANDLER_IMPLEMENT_VOIDCONTROL(OptionWindow, OnButtonControlCancel, result, control)
{
    unused(result);
    unused(control);

    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}

HANDLER_IMPLEMENT_VOIDCONTROL(OptionWindow, OnEditboxHandler, result, control)
{
    control->SetStatusTarget(false);
    if (result) {
        next = control->GetNext(TYPE_WILDCARD, ATTRIBUTE_WILDCARD);
        if (next != null) {
            next->SetStatusFocus(true);
        }
    }
    return;
}

HANDLER_IMPLEMENT_VOIDCONTROL(OptionWindow, OnCheckboxSSL, result, control)
{
    unused(result);
    unused(control);

    _radioSSLTrustmode[0]->SetStatusEnable(_checkboxUseSSL->GetStatusCheck());
    _radioSSLTrustmode[1]->SetStatusEnable(_checkboxUseSSL->GetStatusCheck());
    _radioSSLTrustmode[2]->SetStatusEnable(_checkboxUseSSL->GetStatusCheck());
    _radioSSLTrustmode[3]->SetStatusEnable(_checkboxUseSSL->GetStatusCheck());
    if (_checkboxUseSSL->GetStatusCheck()){
        _ssltext->SetColor(SFRLabelControl::COLOR_TITLE,SFXRGBColor(0, 0, 0, 0));
    }
    else {
        _ssltext->SetColor(SFRLabelControl::COLOR_TITLE,SFXRGBColor(150, 150, 150,0));
    }
}

