#include "SendingWindow.hpp"
#include "simplemailer.hpp"
#define MARGIN 8
#define BUTTON_LABEL_OK     "M"
#define BUTTON_LABEL_CANCEL "LZ"
SendingWindow::SendingWindow(Void) : SFRTitleWindow(
SFRApplication::GetInstance(), SFXGraphics::GetDeviceRectangle(), "[M")
{
    // L[ nho^
    if (static_try()) {
        static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }
    SInt16 fontHeight = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
    SFXRectangle rectLeft(MARGIN, MARGIN, 0, fontHeight + 2);
    SFXRectangle rectRight(GetContentWorld());
    rectLeft.SetWidth(SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, "From") + MARGIN);
    rectRight.Deflate(MARGIN, MARGIN);
    rectRight.SetLeft(rectLeft.GetRight());
    rectRight.SetHeight(fontHeight + 2);
    rectLeft.SetRight(rectRight.GetLeft() - MARGIN);

    // x̍쐬
    ::new SFRLabelControl(this, rectLeft, "From");
    // eLXgRg[̍쐬
    _textControlFrom = ::new SFREditboxControl(this, rectRight, "");
    _textControlFrom->SetInputMode(AEE_TM_LETTERS);     //̓[hݒFAt@xbg
    _textControlFrom->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    ::new SFRLabelControl(this, rectLeft, "To");
    _textControlTo = ::new SFREditboxControl(this, rectRight, "");
    _textControlTo->SetInputMode(AEE_TM_LETTERS);       //̓[hݒFAt@xbg
    _textControlTo->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

    rectLeft.AddY(MARGIN + fontHeight);
    rectRight.AddY(MARGIN + fontHeight);
    ::new SFRLabelControl(this, rectLeft, "薼");
    _textControlSubject = ::new SFREditboxControl(this, rectRight, "");
    _textControlSubject->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

    rectLeft.AddY(MARGIN + fontHeight);
    ::new SFRLabelControl(this, rectLeft, "{");
    rectLeft.AddY(MARGIN + fontHeight);
    rectLeft.SetBottom(GetContentWorld().GetBottom() - rectLeft.GetHeight() - 2 * MARGIN);
    rectLeft.SetRight(GetContentWorld().GetRight() - MARGIN);
    _textControlBody = ::new SFREditboxControl(this, rectLeft, "");
    _textControlBody->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));
    rectRight.SetX(rectLeft.GetX());
    rectRight.SetY(rectLeft.GetBottom() + MARGIN);
    rectRight.SetWidth(SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, BUTTON_LABEL_OK) + 2 * MARGIN);

    // {^̍쐬
    SFRButtonControlPtr buttonOk = ::new SFRButtonControl(this, rectRight, BUTTON_LABEL_OK);
    rectRight.AddX(rectRight.GetWidth() + MARGIN);
    rectRight.SetRight(GetContentWorld().GetRight() - MARGIN);
    SFRButtonControlPtr buttonCancel = ::new SFRButtonControl(this, rectRight, BUTTON_LABEL_CANCEL);

    if (_textControlFrom != null) {
        // eLXgRg[̍őTCYݒ
        _textControlFrom->SetMaxSize(255);
        // tH[JX𓖂Ă
        _textControlFrom->SetStatusFocus(true);
    }
    if (_textControlTo != null) {
        _textControlTo->SetMaxSize(255);
    }
    if (_textControlSubject != null) {
        _textControlSubject->SetMaxSize(255);
    }
    if (_textControlBody != null) {
        _textControlBody->SetMaxSize(SINT16_MAXIMUM);
    }
    // {^nh̓o^
    if (static_try()) {
        static_throw(
        buttonOk->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlOk)));
    }
    if (static_try()) {
        static_throw(
        buttonCancel->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlCancel)));
    }
    // ZNgL[Ƃ̃nho^ (eLXgRg[p)
    if (static_try())  {
        static_throw(
        RegisterHandler(
        SFEVT_KEY, AVK_SELECT, HANDLER_AFTER,
        HANDLER_FUNCTION(SelectHandler)));
    }
    return;
}


SendingWindow::~SendingWindow(Void)
{
    return;
}


// L[ nh
HANDLER_IMPLEMENT_BOOLEVENT(SendingWindow, OnKey, event)
{
    switch (event.GetP16()) {
    case AVK_CLR:
        // NA[ L[ꂽA
        if (_textControlFrom->GetStatusTarget() || _textControlTo->GetStatusTarget() ||
        _textControlSubject->GetStatusTarget() || _textControlBody->GetStatusTarget()) {
            _textControlFrom->SetStatusTarget(false);
            _textControlTo->SetStatusTarget(false);
            _textControlSubject->SetStatusTarget(false);
            _textControlBody->SetStatusTarget(false);
            FocusNext();
        }
        else {
            // EBhE̔j
            return Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
        }
        // tH[JXړ
    case AVK_UP:
        FocusPrevious();
        return true;
    case AVK_DOWN:
        FocusNext();
        return true;
    }
    return false;
}


HANDLER_IMPLEMENT_VOIDCONTROL(SendingWindow, OnButtonControlOk, result, control)
{
    unused(result);
    unused(control);

    SFCError error;
    // AvNXݒf[^擾
    SFXConfigPtr option = simplemailer::GetOption();
    // [ bZ[W\NX
    SFXMailMessage message;
    // From AhXݒ
    message.SetFromField(_textControlFrom->GetText());
    // To AhXݒ
    message.ReplaceToField(_textControlTo->GetText());
    // ^Cgݒ
    message.SetSubjectField(_textControlSubject->GetText());
    // {ݒ
    message.SetBody(_textControlBody->GetText());
    // Mp[T[oƃ|[gԍw (hC͎)
    _sender.SetServer(SFXSocketAddress(
    option->ReadSFXAnsiString(OPTION_SMTPSERVER, ""),
    option->ReadUInt16(OPTION_SMTPPOPT, 25)));

    // SSLڑgpAFؕ@ݒ
    Bool UseSSL=option->ReadBool(OPTION_USESSL, false);
    if ( UseSSL == true ) {
        _sender.SetSSLMode(UseSSL);
        SInt16 trustmode=option->ReadSInt16(OPTION_SSLTRUSTMODE,0);
        switch (trustmode) {
        case 0:
        default:
            _sender.SetTrustMode(SSL_TRUST_MODE_FAIL);
            break;
        case 1:
            _sender.SetTrustMode(SSL_TRUST_MODE_CHECK);
            break;
        case 2:
            _sender.SetTrustMode(SSL_TRUST_MODE_IGNORE);
            break;
        case 3:
            _sender.SetTrustMode(SSL_TRUST_MODE_ALWAYS);
            break;
        }
    }

    // SMTPFؕ@ݒ
    SInt16 smtpauth=option->ReadSInt16(OPTION_SMTPAUTHMODE,0);
    switch (smtpauth) {
    case 0:
    default:
        error=_sender.SetAuthorization(SFXSMTPSender::AUTH_NONE,"","");
        break;
    case 1:
        error=_sender.SetAuthorization(SFXSMTPSender::AUTH_PLAIN,
        option->ReadSFXAnsiString(OPTION_USER, ""),
        option->ReadSFXAnsiString(OPTION_PASSWORD, ""));
        break;
    case 2:
        error=_sender.SetAuthorization(SFXSMTPSender::AUTH_LOGIN,
        option->ReadSFXAnsiString(OPTION_USER, ""),"");
        break;
    case 3:
        error= _sender.SetAuthorization(SFXSMTPSender::AUTH_CRAM_MD5,
        option->ReadSFXAnsiString(OPTION_USER, ""),
        option->ReadSFXAnsiString(OPTION_PASSWORD, ""));
        break;
    case 4:
        // DIGEST_MD5 is not supported yet.
        error=  _sender.SetAuthorization(SFXSMTPSender::AUTH_NONE,"","");
        break;
    }
    if (error != SFERR_NO_ERROR) {
        _sender.Cancel();
    }

    // [𑗐M (R[obNo^)
    error = _sender.SendMessage(&message, XALLBACK_INTERNAL(SMTPCallback));
    if (error == SFERR_NO_ERROR) {
        // G[NȂ
        // _CAO̍쐬
        _dialog = ::new SFRMessageDialog(SFXGraphics::GetDeviceRectangle()
        .Deflate(20, 80), "Mc", "LZ");
        if (_dialog != null) {
            // _CAOnh̓o^
            _dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE,
            HANDLER_FUNCTION(OnSending));
        }
    }
    else {
        // _CAO̍쐬
        _dialog = ::new SFRMessageDialog(SFXGraphics::GetDeviceRectangle()
        .Deflate(20, 80), "MɎs܂B", "OK");
        _sender.Cancel();
        if (_dialog != null) {
            // _CAOnh̓o^
            _dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE,
            HANDLER_FUNCTION(OnDialog));
        }
    }
}


HANDLER_IMPLEMENT_VOIDCONTROL(SendingWindow, OnButtonControlCancel, result, control)
{
    unused(result);
    unused(control);

    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}


XALLBACK_IMPLEMENT_SFXSMTPSENDER(SendingWindow, SMTPCallback ,error )
{
    SFXWideString message;
    if (error == SFERR_NO_ERROR) {
        message.Set("Mɐ܂B");
    }
    else {
        message.Set("MɎs܂B1");
        _sender.Cancel();
        DBGPRINTF("er:%d",error);
    }
    if (_dialog != null) {
        // uMcv_CAO
        _dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
        SRP16_TERMINATE_INVOKE, true));
    }
    // _CAO̍쐬
    _dialog = ::new SFRMessageDialog(SFXGraphics::GetDeviceRectangle()
    .Deflate(20, 80), message, "OK");
    if (_dialog != null) {
        // _CAOnh̓o^
        _dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnDialog));
    }
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
    SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
}


// _CAO nh̒`
HANDLER_IMPLEMENT_VOIDDIALOG(SendingWindow, OnDialog, result, dialog)
{
    unused(result);

    // _CAO
    dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
    SRP16_TERMINATE_INVOKE, true));
    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
    SRP16_TERMINATE_INVOKE, true));
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
    SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
}


HANDLER_IMPLEMENT_VOIDDIALOG(SendingWindow, OnSending, result, dialog)
{
    unused(result);

    // _CAO
    dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,
    SRP16_TERMINATE_INVOKE, true));
    _sender.Cancel();
    // ĕ`
    SFRApplication::GetInstance()->Invoke(
    SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
}


HANDLER_IMPLEMENT_VOIDCONTROL(SendingWindow, OnEditboxHandler, result, control)
{
    if (result) {
        next = control->GetNext(TYPE_WILDCARD, ATTRIBUTE_WILDCARD);
        if (next != null) {
            control->SetStatusTarget(true);
        }
        else control->SetStatusTarget(false);
        next->SetStatusFocus(true);
    }
    else control->SetStatusTarget(false);
    next->SetStatusFocus(true);
    return;
}

